void PowerON_Reset_PC(void);

#pragma section P GRResetPRG // Section Name is GRResetPRG

#define RXSDBG // please comment out for release build

#if defined(RXSDBG) // for RX Serial Debugger
#pragma inline_asm RXSerialDebuggee_Signature
void RXSerialDebuggee_Signature(void)
{
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    mvtc    #0FFE00000H:24, INTB    // .byte 0xfd, 0x7f, 0x0c, 0x00, 0x00, 0xe0
    brk                             // .byte 0x00
    nop                             // .byte 0x03
    brk                             // .byte 0x00
    brk                             // .byte 0x00
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    brk                             // .byte 0x00
    brk                             // .byte 0x00
    brk                             // .byte 0x00
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    brk                             // .byte 0x00
    brk                             // .byte 0x00
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    brk                             // .byte 0x00
    nop                             // .byte 0x03
}
#else // for USBMSC firmware corresponding to CC-RX
#pragma inline_asm Not_RXSerialDebuggee
void Not_RXSerialDebuggee(void)
{
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    mvtc    #0FFE00000H:24, INTB    // .byte 0xfd, 0x7f, 0x0c, 0x00, 0x00, 0xe0
    nop                             // .byte 0x03
    brk                             // .byte 0x00
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    brk                             // .byte 0x00
    brk                             // .byte 0x00
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    brk                             // .byte 0x00
    brk                             // .byte 0x00
    brk                             // .byte 0x00
    nop                             // .byte 0x03
    nop                             // .byte 0x03
    brk                             // .byte 0x00
    brk                             // .byte 0x00
    nop                             // .byte 0x03
    brk                             // .byte 0x00
}
#endif

void GR_PowerON_Reset_PC(void)
{
    PowerON_Reset_PC();
}

// Undef R_CGC_SetAll by this 2nd time inclusion
// (1st time inclusion is made by a command line's pre-include option)
#include "rxsdbghook.h"

bool RXSerialDebuggee_Hook_R_CGC_SetAll(
    const uint8_t selection,
    const uint32_t control,
    const double source_clock_freq,
    const double required_system_clock_freq,
    const double required_peripheral_clock_a_freq,
    const double required_peripheral_clock_b_freq,
    const double required_flash_clock_freq,
    const double required_bus_clock_freq,
    const double required_iebus_clock_freq,
    const double required_usb_clock_freq,
    const uint16_t sub_waiting_time)
{
#if defined(RXSDBG) // for RX Serial Debugger
#include "r_pdl_cgc.h"
    if (selection == PDL_CGC_CLK_PLL)
    {
        return true;
    }
#endif
    return R_CGC_SetAll(
    selection,
    control,
    source_clock_freq,
    required_system_clock_freq,
    required_peripheral_clock_a_freq,
    required_peripheral_clock_b_freq,
    required_flash_clock_freq,
    required_bus_clock_freq,
   required_iebus_clock_freq,
    required_usb_clock_freq,
    sub_waiting_time);
}
